#!/usr/bin/perl

# time.cgi -- authored by paal@ekran.no, Wed Jan  5 08:49:13 CET 2000
# ---------------------------------------------------------------------

# Time Manager is a system that keeps track of how much time you have
# spent at work (or whatever). This system is ideal at workplaces which
# has a flexible time system.

# ---------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA02111-1307, USA.
# ---------------------------------------------------------------------

use Date::Manip;
use CGI qw(:cgi-lib);

# ---------------------------------------------------------------------
# the hostname, starting with http://, no trailing / 
$web_host='http://www.student.uit.no';

# here's a relative path used in the forms.
$cgi_action='/~paalde/internal/time/time.cgi';

# you should not alter the next line.
$cgi_url=$web_host.$cgi_action;

# comment out the language you don't want, if you comment out more than
# one language, the last language you comment out will be the default.
lang_eng(); # only english is currently supported.

# date_format. which is (day/month-year hour:minute:seconds)
# see the Date::Manip man pages if you want to change this.
# these are visual changes only (for status/report pages, etc)
$date_format="%d/%m-%Y %H:%M:%S";
$date_formatD="%d/%m";
$date_formatT="%H:%M:%S";

$default_cs=4; # default colour scheme

# --- NOT MUCH TO WORRY ABOUT ANYTHING BELOW THIS POINT ---
 
color_scheme($default_cs);
$std_table='<table border=1 cellpadding=2 bgcolor="'.
		$table_bgcolor.'" align="center">';
$std_tableL='<table border=1 cellpadding=2 bgcolor="'.$table_bgcolor.'">';

# mandatory workhours per week. the difference betwenn this and actual
# worked workhours are either overtime or time that the employee has to
# work inn.

$hours_a_day=7.5;
$hours_weekly=(5*$hours_a_day);

# $first day of week (1=monday)
$first=1;

# ---------------------------------------------------------------------
# initialize -- nothing below this point should be altered! 

$VERSION="0.6.0";
$NAME="Time Manager";
$ENV{PATH}="/bin:/usr/bin";
&Date_Init("Language=English","DateFormat=non-US");

&ReadParse(*data);

$uact=$data{"UACT"}; # get current action

if ($uact eq "login")
{
	$unam=$data{"UNAME"};
	$upwd=$data{"UPWD"};
}

# a list of legal UACT "commands" (must start and end with a whitespace)
$commands=" config config2 config3 config4 config5 signon signoff yearly monthly monthly2 weekly week.exe delete del.exe change change2 change3 insert insert2 logout schedule schedule2 schedule3 ";

$dat=`date`;
chomp $dat;

$entries=0;
$this_year=&UnixDate($dat,"%Y"); # this_year is current year YYYY
$this_ryear=&UnixDate($dat,"%Y"); # this_year is current year YYYY (always)
$this_day=&UnixDate($dat,"%j");

# --- user authentication handlers
if ($uact eq "logout") { logout(); }

$foo=0;
if ($uact eq "login")
{
	authenticate_setcookie($unam,$upwd); # attemp to set a cookie
	$foo=1;
} else {
	print &PrintHeader;
	# try to grab the cookie user info. foo == 0 if cookie or input is bad.
	($foo,$unam,$upwd)=authenticate_parse_cookie();
}
if ($foo==0) { authenticate_user(); } # display the login screen

if (-e 'data/'.$unam.'.prefs')
{
	open TXT,"<data/".$unam.".prefs" || print "can not open pref file.";
	while (<TXT>)
	{
		chomp;
		($key,$value)=split /:/;
		if ($key eq "cy") {$this_year=$value;}
	}
}

(@dblist)=read_datafile($unam);  # read the datafile
$entries=pop @dblist;
(@slist)=read_sfile($unam);  # read schedule file

if (!($uact)) # no command given, write menu screen
{
	$the_user=chk_user($unam,$upwd); # just grab user name
	head(1);
	color_scheme($scheme);	
	menu_page();
	tail(2);
	exit 0;
}

head(); # print web header.
color_scheme($scheme);	

# find scheduled time available at the start of the year.

init_datafile(); # create .prefs file unless it exist.

open TXT,"<data/".$unam.".prefs" || print "cant read from pref file.";
while (<TXT>)
{
	chomp;
	($cmd,$parm)=split /:/;
	if ($cmd eq "cx".$this_year) { $this_scheduled=$parm; }
}
close TXT;

# ---------------------------------------------------------------------------
# check for errors

$err=0;
if (!($the_user=chk_user($unam,$upwd))) # check user authentication
{
    print $l_auth_failed."<br>\n";
	$err++; 
}

$foo=" ".$uact." ";
$_=$commands;
if (!(m/$foo/i ))
{
    print $l_action_n_spec."<br>\n";
    $err++;
}

# check previous entry -- we can't login/-out twice in a row
$line=$dblist[$entries];
($id,$action,$date)=split /;/,$line;
if (($uact eq "signoff") && ($id/2==(int($id/2)))) {
   print "<br>".$l_bad_seq."<br>\n"; $err++;
}
if (($uact eq "signon") && ($id/2!=(int($id/2)))) {
   print "<br>".$l_bad_seq."<br>\n"; $err++;
}

# ---------------------
# debug section
# foreach $line (@dblist) { print "->".$line."<-<br>\n"; } 


# ---------------------------------------------------------------------------
# no errors found lets get goin'

print "<br>\n";
if ($err==0) {
    if (($uact eq "signon") || ($uact eq "signoff"))
	{
       add_entry();
    } 
    if ($uact eq "yearly") { exec_yearly(); }
    if ($uact eq "monthly") { monthly_select("monthly2"); }
    if ($uact eq "monthly2") { exec_monthly(); }
    if ($uact eq "weekly") { select_week(); }
    if ($uact eq "week.exe") { mkweek2(); }
    if ($uact eq "delete") { prep_delete(); }
    if ($uact eq "del.exe") { exec_delete(); }
    if ($uact eq "change") { prep_change(); }
    if ($uact eq "change2") { exec_change(); }
    if ($uact eq "change3") { exec_change2(); }
	if ($uact eq "insert") { prep_insert(); }
	if ($uact eq "insert2") { exec_insert(); }
    if ($uact eq "schedule") { monthly_select("schedule2"); }
    if ($uact eq "schedule2") { exec_schedule2(); }
    if ($uact eq "schedule3") { exec_schedule3(); }
    if ($uact eq "config") { exec_config(); }
    if ($uact eq "config2") { exec_config2(); }
    if ($uact eq "config3") { exec_config3(); }
    if ($uact eq "config4") { exec_config4(); }
    if ($uact eq "config5") { exec_config5(); }
	
}
tail(0);
exit 0;


# ---------------------------------------------------------------------------
# subroutines
# ---------------------------------------------------------------------------

# ---------------------------------------------------------------------------
# COOKIE AUTHENTICATION

# authenticate_parse_cookie reads and parses the cookie environment variable\
# then returns username and password if it finds any.

sub authenticate_parse_cookie() 
{
	my $ck;
	my $key;
	my $value;
	my $kv;
	my $unam;
	my $upwd;

	$ck=0;
	@cookies=split (/;\s/,$ENV{'HTTP_COOKIE'}); # splits the cookies add table
	foreach $kv (@cookies)
	{
		($key,$value)=split (/=/,$kv);
		if ($key eq "user") {$unam=$value;}
		if ($key eq "pwd") {$upwd=$value;}
	}

	if (($unam) && ($upwd)) { $ck=1; }
	return ($ck,$unam,$upwd);
}

sub authenticate_user() # writes the html login screen.
{
	head();
	login_page();
	tail(1);
	exit 0;
}

sub authenticate_setcookie()
{
	my ($user,$pwd)=@_;
	
	print "Content-Type: text/html\n"; 
	if ($the_user=chk_user($user,$pwd))
	{
		print "Set-Cookie: user=".$user.";","\n";
		print "Set-Cookie: pwd=".$pwd.";","\n\n";

		$uact=""; # this forces a printout of the menu screen	
	} else {
		print "\n";
		head("nc");
		print '<center><br><b>User failed to authenticate.</b><br>
					press back and try again.</center>'."\n";
		tail(1);
		exit 0;
	}	
	return ($user,$pwd);
}

sub logout() # log user off the system.
{
	print "Content-Type: text/html\n"; 
	print "Set-Cookie: user=;","\n";
	print "Set-Cookie: pwd=;","\n\n";

	color_scheme($default_cs);	
	head();
	print '<center><br><b>'.$l_logedout.'</b><br><br><b>Or you may
			<a href="'.$cgi_url.'?login">login</a> again.</b></center>'."\n";
	tail(1);
	exit 0;
}

# ---------------------------------------------------------------------------
# DISPLAY LOGIN SCREEN

sub login_page() 
{
	print '<form action="'.$cgi_action.'" method="POST">
			'.$std_table.'
			<tr>
  				<th colspan="3">'.$text_hcolor.'AUTHENTICATE USER</font></th>
			</tr>
			<tr>
  				<td>Username:</td>
  				<td align=right colspan=2>
					<input type="text" name="UNAME" size="8"></td>
			</tr>
			<tr>
  				<td>Password:</td>
  				<td align=right colspan=2>
					<input type="password" name="UPWD" size="8"></td>
			</tr>
			<tr>
  				<td align="right" colspan="3">
  				<input type="submit" value="'.$l_continue.'">
  				<input type="reset" value="'.$l_reset.'"></td>
			</tr>
			</table>
			<input type="hidden" name="UACT" value="login">
			</form>';
}


# ---------------------------------------------------------------------------
# DISPLAY MENU SCREEN

sub menu_page()
{

print '<form action="'.$cgi_action.'" method="POST">
		'.$std_table.'
		<tr>
  			<th colspan="3">'.$text_hcolor.'WORK HOURS REGISTRATION</font></th>
		</tr>
		<tr>
  			<td>Sign on/off</td>
			<td align="right" colspan="2">
				<input type="submit" name="UACT" value="signon">
      			<input type="submit" name="UACT" value="signoff"></td>
		</tr>
			<tr><td colspan="3"><font size="-3">&nbsp;</font></td></tr>
		<tr>
  			<td>Reports</td>
  			<td align="right" colspan="2">
      		<input type="submit" name="UACT" value="yearly">
      		<input type="submit" name="UACT" value="monthly">
			<input type="submit" name="UACT" value="weekly"></td>
		</tr>
		<tr>
  			<td>Change/Delete/Insert entry</td>
  			<td align="right" colspan="2">
				<input type="submit" name="UACT" value="change">
				<input type="submit" name="UACT" value="delete">
				<input type="submit" name="UACT" value="insert"></td>
		</tr>
		<tr>
  			<td>Scheduler</td>
  			<td align="right" colspan="2">
				<input type="submit" name="UACT" value="schedule"></td>
		</tr>
		<tr>
			<td colspan="3"><font size="-3">&nbsp;</font></td>
		</tr>
		<tr>
  			<td>Preferences/Logout</td>
  			<td align="right" colspan="2">
			<input type="submit" name="UACT" value="config">
			<input type="submit" name="UACT" value="logout">
			</td>
		</tr>

		</table>
		</form>
	';
}

# ---------------------------------------------------------------------------
# ADD ENTRY

sub add_entry()
{
	if ($uact eq "signon") { $action="inn"; } else { $action="out"; }

	if ($this_year ne &UnixDate($dat,"%Y"))
	{
		print 'You can not '.$uact.' when current year aint system year. If you
with to '.$uact.' then change the log view year in the configuration menu.<br>';
		tail();
		exit 0;
	}

   	open DTA,">>data/".$unam.".".$this_year.".dta" ||
    	print "can't open datafile for writing...<br>\n";
	print DTA ($next_entry+1).";".$action.";".&ParseDate($dat)."\n";
	close DTA;
	print $uact." ".$l_confirm_action." at ".
			&UnixDate($dat,$date_format)."<br>\n";
}



# -----------------------------------
# writes the main configuration menu.
sub exec_config()
{

	# get current colour selection.

	my $ccol;

	init_datafile();
    open TXT,"<data/".$unam.".prefs" || print "can not open pref file.";
	while (<TXT>)
	{
		chomp;
		($cmd,$parm)=split /:/;
		if ($cmd eq "cs") { $ccol=$parm;}
	}
	close TXT;

	print $std_table;
	print '<tr><th colspan="2">System Configuration</th></tr>
<tr><td><font size="-3">&nbsp;</font></td></tr>

<tr><td>
<table width="100%">
<tr>
	<td valign="middle">Change log view year:</td>
	<td align="right" valign="middle">
<form action="'.$cgi_action.'" method="POST">
<input type="text" name="CH_YEAR" value="'.$this_year.'" size="4">
<input type="hidden" name="UACT" value="config4">
<input type="submit" value="change">
</form>
	</td></tr>
<tr><td colspan="2" align="center">
<font size="-1">Use this to view or alter entries from previous years.
</font></td>
</tr></table>

<tr><td><font size="-3">&nbsp;</font></td></tr>

<tr><td>
<form action="'.$cgi_action.'" method="POST">
<br>
Change scheduled time state (at start of year)<br>
Enter year (YYYY): <input type="text" name="OYEAR" size="4">
Enter work hours:  <input type="text" name="OHRS" size="8">
   <input type="hidden" name="UACT" value="config5">
   <input type="submit" value="change">
</form>
<center>
<font size="-1">Use this feature to set the initial scheduled hours,
  i.e. hours that you<br> have saved previous to the current year.
  Use -(number) if this number is negative.<br>
  Read the manual if you are uncertain about this.
</font></center>
</td></tr>

<tr><td><font size="-3">&nbsp;</font></td></tr>

<tr><td>
<form action="'.$cgi_action.'" method="POST">
<table width="100%">
<tr>
	<td colspan="2"><br>Change colour scheme:</td>
	<td align="right" valign="middle"><br><select name="SCHEME">
<option value="'.$ccol.'">';

colname($ccol);
if ($ccol!=1) { print '<option value="1">'; colname(1); }
if ($ccol!=6) { print '<option value="6">'; colname(6); }
if ($ccol!=5) { print '<option value="5">'; colname(5); }
if ($ccol!=8) { print '<option value="8">'; colname(8); }
if ($ccol!=9) { print '<option value="9">'; colname(9); }
if ($ccol!=4) { print '<option value="4">'; colname(4); }
if ($ccol!=7) { print '<option value="7">'; colname(7); }
if ($ccol!=2) { print '<option value="2">'; colname(2); }
if ($ccol!=3) { print '<option value="3">'; colname(3); }

print '</select>
<input type="hidden" name="UACT" value="config3">
<input type="submit" value="change">
</td></tr>
</table>
</form>
</td></tr>


<tr><td><font size="-3">&nbsp;</font></td></tr>

<tr><td>
<form action="'.$cgi_action.'" method="POST">
<table>
<tr><td align="right">Old password
	    <input type="password" name="OPWD" size="8"></td>
	<td>
		<input type="submit" value="change password">
	</td>
</tr>
<tr><td align="right">New password
	   <input type="password" name="NPWD" size="8"></td>
	<td>Repeat new password
	   <input type="password" name="NPWD2" size="8"></td>
	   <input type="hidden" name="UACT" value="config2"></td>
</tr>
</table>
</form>

<tr><td><font size="-3">&nbsp;</font></td></tr>

</td></table>
';
}

sub colname() # print the realname of the currently selected scheme.
{
	($cl)=@_;
	if ($cl==1) { print "arctic"; }
	if ($cl==2) { print "oranges"; }
	if ($cl==3) { print "toxic"; }
	if ($cl==4) { print "concrete"; }
	if ($cl==5) { print "bluebird"; }
	if ($cl==6) { print "be"; }
	if ($cl==7) { print "darkness"; }
	if ($cl==8) { print "caramel fudge"; }
	if ($cl==9) { print "colgate"; }
	print "\n";
}

sub exec_config4()
{
	my @fozi;

	@fozi=();
	print "Changing current log view year to ".$data{"CH_YEAR"}."<br>\n";
	init_datafile();
	$chk=0;
	open TXT,'<data/'.$unam.'.prefs';
	while (<TXT>)
	{
		chomp;
		($key,$val)=split /:/;
		if ($key ne "cy") { push @fozi,$key.":".$val; }
	}
	close TXT;
	if ($data{"CH_YEAR"} ne &UnixDate($dat,"%Y")) # only insert different year
	{
		push @fozi,"cy:".$data{"CH_YEAR"}; # if not eq system year
	}

	open TXT,">data/".$unam.'.prefs'; # writeback config file.
	foreach $line (@fozi)
	{
		print TXT $line."\n";
	}
	close TXT;

}

sub exec_config3()
{
	my @cflst;

	@cflst=();
# check integrity of config file (if it exist and contain cs: variable)

	init_datafile();

	$ck=0;
	open TXT,"<data/".$unam.".prefs" || print "can not open pref file.";
	while (<TXT>)
	{
		chomp;
		($cmd,$parm)=split /:/;
		if ($cmd ne "cs") { push @cflst,$cmd.":".$parm; }
	}
	close TXT;
    push @cflst,"cs:".$data{"SCHEME"};

	open TXT,">data/".$unam.".prefs" || print "can not write to pref file.";
	foreach $line (@cflst)
	{
		print TXT $line."\n";
	}
	close TXT;
	print '<center>
			Scheme changed. Go to the main menu to view the effect!<br>
	</center>';
}

# write scheduled hours at start of year.
sub exec_config5()
{

	my $oyear=$data{"OYEAR"};
	my $ohrs=$data{"OHRS"};

	my @cflst=();

	if ($ohrs<0) { $fc=$text_red; } else { $fc=$text_black; }

	print '<ul>Writing to datafile...<br><br>';
	init_datafile();

	open TXT,"<data/".$unam.".prefs" || print "can't open pref file.";
	while (<TXT>)
	{
		chomp;
		($cmd,$parm)=split /:/;
		if ($cmd ne "cx".$oyear) { push @cflst,$cmd.":".$parm; }

	}
	close TXT;
	push @cflst,"cx".$oyear.":".$ohrs;

	open TXT,">data/".$unam.".prefs" || print "can not write to pref file.";
	foreach $line (@cflst)
	{
		print TXT $line."\n";
	}
	close TXT;

	print 'At the start of year '.$oyear.' you have now have
'.$fc.''.$ohrs."</font> hours (available or
hours that you need to work in.)
<br></ul>";
	
}

# if .prefs file does not exist, we create it here.
sub init_datafile()
{
	if (! -e 'data/'.$unam.'.prefs')
	{
		open TXT,">data/".$unam.".prefs" || print "can not write to pref file.";
		print TXT "cs:1";
		close TXT;
	}
}

sub exec_config2() # aka. the change password exec.
{
	my $luser;
	my $lpwd;
	my $salt;
	my $opwd=$data{"OPWD"};
	my $npwd=$data{"NPWD"};
	my $npwd2=$data{"NPWD2"};

	my $fck;
	my $ck;
	my @plst;

	$fck=0;
	@plst=();	
	$ck=0;

	if ((length($npwd)<6) || (length($npwd)>9))
	{
		print '<center>
				The password should be between 6 and 9 characters long!<br>
				Press back and try again.
				</center>';
		$ck=1;
	}
	if ($npwd ne $npwd2)
	{
		print '<center>
				The two new password does not match!<br>
				Press back and try again.
				</center>';
		$ck=1;
	}
	if ($npwd eq $opwd)
	{
		print '<center>
				Old password and new password are equal!<br>
				Press back and try again.
				</center>';
		$ck=1;
	}

	if ($ck==0)
	{
		@plst=();
		open PWD,"<time.pwd";
		while (<PWD>)
		{
			chomp;
			($luser,$foo,$lpwd)=split /:/; # lpwd = crypt password.
	
			$salt=substr($lpwd,0,2);
			$lcrypt=crypt($opwd,$salt); # compare old crypt

			if (($lcrypt eq $lpwd) && ($luser eq $unam))
			{
				$fck=1;
				$salt=join '',('.','/',0..9,'A'..'Z','a'..'z')[rand 64,rand 64];
				$ncrypt=crypt($npwd,$salt); # make new crypt
				push @plst,$luser.":".$foo.":".$ncrypt;
			} else {
				push @plst,$luser.":".$foo.":".$lpwd;
			}
			if (($luser eq $unam) && ($lcrypt ne $lpwd))
			{
				$fck=-1;
				print '<center>
				    The old password was wrong!<br>
					Press back and try again.
				</center>';
			}
		}
		close PWD;

		if ($fck==1)
		{
			open PWD,">time.pwd";
			foreach $line (@plst)
			{
				print PWD $line."\n";
			}
			close PWD;
			print '<center>
	    Your password has been changed!<br>
		You should now <a href="'.$cgi_url.'?UACT=logout">login</a> from start.
			</center>';
		}
	}
}



# ---------------------------------------------------------------------------
# CHANGE ENTRY SUBS

# ------------------------------------------
# prepare change (write change alternatives)
sub prep_change()
{
	print '<form action="'.$cgi_action.'" method="POST">';
	print $std_tableL."\n";
	print '<tr><th colspan=3>'.$text_hcolor.$l_alter_select_entry.
			'</th></tr>';
	print '<tr><td>&nbsp;</td><th>'.
				$l_from.'</th><th>'.$l_to.'</th></tr>'."\n"; 
	$inn="empty"; $out="empty"; $cnt=0; 
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ($inn eq "empty")
			{ $inn=$date; $ice=$id } else { $out=$date; }
		if ($out ne "empty")
		{
			if ($out eq "nempty") { $out=$l_still_online; }
			print '<td>
					<input type="checkbox" name="U'.$ice.'" value="unset">
					</td>
				   <td>'.&UnixDate($inn,$date_format).'</td><td>';
			if ($out eq $l_still_online)
			{
				print $l_still_online;
			} else {
				print &UnixDate($out,$date_format);
			}
			print '</td></tr>'."\n";
			$inn="empty"; $out="empty"; $cnt++;
		} 
	}
	print '<td colspan="3" align="right">
				<input type="submit" value="'.$l_continue.'">
			</td></tr>
			</table>
			<input type="hidden" name="UACT" value="change2">
			</form>';
}

sub exec_change()
{
	print '<form action="'.$cgi_action.'" method="POST">';

	print $std_tableL."\n";
	print '<tr><th colspan=7>'.$text_hcolor.$l_alter_changeent.'</th></tr>';
	print '<tr><th>original</th>
               <th>day</th>
               <th>mon</th>
               <th>&nbsp;</th>
               <th>hrs</th>
               <th>min</th>
               <th>sec</th></tr>'."\n";

	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ((($data{"U".$id} eq "unset") || 
			($data{"U".($id-1)} eq "unset")) && ($date ne "nempty"))
		{
			print '<tr><td>'.&UnixDate($date,$date_format).'</td>';
			print '  <td><input type="text" size="2" name="dayU'.$id.'" value="'.&UnixDate($date,"%d").'"></td>';
			print '  <td><input type="text" size="2" name="monU'.$id.'" value="'.&UnixDate($date,"%m").'"></td>';
			print '  <td>&nbsp;</td>';

			print '  <td><input type="text" size="2" name="hrsU'.$id.'" value="'.&UnixDate($date,"%H").'"></td>';
			print '  <td><input type="text" size="2" name="minU'.$id.'" value="'.&UnixDate($date,"%M").'"></td>';
			print '  <td><input type="text" size="2" name="secU'.$id.'" value="'.&UnixDate($date,"%S").'"></td>';
			print '</tr>'."\n";
			if (($id/2)==(int($id/2)))
				{ print '<tr><td></td></tr>'; }
		}
	}
    print '<tr><td colspan="7" align=right>
				<input type="submit" value="'.$l_continue.'">
    			<input type="reset" value="'.$l_reset.'">
			</td></tr>';
    print '</table>
			<input type="hidden" name="UACT" value="change3">
           </form>';
}

sub exec_change2() { # perform the actual change

	my $idn; # id next.
	my $thise; # a regular tuppel counter
	my ($md,$mm,$mh,$mi,$ms,$ctl);
	my ($prev,$next,$thise,$nowrite);

	print "<b>".$l_alter_entries."</b><p>";
	print "<ul>";

	$thise=0; $nowrite=1;
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		$ctl=0;
		$thise++;
		if ($data{"dayU".$id})
		{
			($prev,$next)=getnextprev($id); # get the next and previous entry
			$mm=$data{"monU".$id};
			$md=$data{"dayU".$id};
			$mh=$data{"hrsU".$id};
			$mi=$data{"minU".$id};
			$ms=$data{"secU".$id};

			$dm_new=$this_year.$mm.$md.$mh.":".$mi.":".$ms;
			$ctl=0;
			
			if ($dm_new ne $date) # check if date has been alter before ctrl.
			{
				if ($data{"dayU".($id+1)}) # next record is also altered
				{
					$idn=($id+1);
					$next=$this_year.
							$data{"monU".$idn}.
							$data{"dayU".$idn}.
							$data{"hrsU".$idn}.":".
							$data{"minU".$idn}.":".
							$data{"secU".$idn};
					if (!(&ParseDate($next)))
					{
						print $l_alter_nextillegal.".<br>";
						$ctl=+1;
					}
				}

				if (($dm_new lt $prev) && (&ParseDate($dm_new)) &&
					(&ParseDate($prev)))
				{
					print $l_alter_eprealt."<br>";
					print '<b>'.$l_alter_current.':</b> ('.
&UnixDate($date,$date_format).")<b> ".$l_alter_new.':</b> ('.
&UnixDate($dm_new,$date_format).")<b> ".$l_alter_prev.':</b> ('.
&UnixDate($prev,$date_format).")<p>";
					$ctl=1;
				}

				if (($dm_new gt $next) && (&ParseDate($dm_new))
					&& (&ParseDate($next)))
				{
					print $l_alter_enextalt."<br>";
					print	'<b>'.$l_alter_current.':</b> ('.
&UnixDate($date,$date_format).")<b> ".$l_alter_new.':</b> ('.
&UnixDate($dm_new,$date_format).")<b> ".$l_alter_next.':</b> ('.
&UnixDate($next,$date_format).")<p>";
					$ctl=+1;
				}

				if ($dm_new gt &ParseDate(`date`)) # can't alter to future
				{
					print $l_alter_futurealt."<br>";
					print '<b> '.$l_alter_current.'</b> ('.
&UnixDate(&ParseDate(`date`),$date_format).') <b>'.$l_alter_new.'</b> ('.
&UnixDate($dm_new,$date_format).')<br>'."\n";	
					$ctl=+1;
				}

				if (!(&ParseDate($dm_new))) # illegal date
				{
					print $l_alter_illegaldate." (".
					$md."/".$mm."-".$this_year." ".$mh.":".$mi.":".$ms.")<br>";
					$ctl=+1;
				}
			}

			print &UnixDate($date,$date_format)." -> ".
				  &UnixDate($dm_new,$date_format)." "; # write date onto scrn.

			if ($dm_new eq $date) { # nothing has been altered.
				print "--> ".$l_alter_noch.".";
				$ctl=0;
			}
		
			if ($ctl!=0) # something went wrong
			{
				print $l_alter_failed.".";
				$nowrite=2;
			}

			if (($ctl==0) && ($dm_new ne $date)) # success!
			{
				$foo=$id.";".$act.";".$dm_new;
				$dblist[($thise-1)]=$foo;
				print "--> ".$l_alter_ch.".";
				if ($nowrite ne 2) { $nowrite=0; }
			}
			print "<br><p>\n";
    	}
	}
	print "</ul>";
	if ($nowrite==0) # write how it went.
	{
		alter_file();
		print '<b>Changes has been saved.</b>';
	} elsif ($nowrite==1) {
		print '<b>No changes were made.</b>';
	} elsif ($nowrite==2) {
		print '<b>NOTE: One or more errors were found.
						No changes were saved!</b>';
	}
	print '<br>';
}

sub alter_file()
{
	open DTA,">".$dtafile; # write new table to datafile.
	foreach $lineb (@dblist)
 	{
		($foo,$foo,$datex)=split /;/,$lineb;
		if ($datex ne "nempty")
		{
			print DTA $lineb."\n"; # a new line
		}
	}
	close DTA;
}

sub getnextprev() # returns next and previous entry in the table
{
	my ($ida)=@_;

	my ($idb,$chk,$linex,$timex,$prev,$next);

	$chk=0;
	foreach $linex (@dblist)
	{
		($idb,$foo,$timex)=split /;/,$linex;
		if ($chk==1) { $next=$timex; $chk=2;} # grab next in next turn
		if (($ida eq $idb) && ($chk==0)) { $chk=1; }
		if ($chk==0) { $prev=$timex; } # grab previous while not found
	}
	return ($prev,$next);
}



# ---------------------------------------------------------------------------
# INSERT

# ---------------------------------------------------------------------------
# prepare insertion by selecting where the insertion should be
sub prep_insert()
{
	print '<form action="'.$cgi_action.'" method="POST">
			<input type="hidden" name="UACT" value="insert2">';
	print $std_tableL."\n";
	print '<tr><th colspan=7>'.$l_insert_please_write.'</th></tr>
			<tr><td>&nbsp;</td><th>'.$l_day.'</th><th>'.$l_month.'</th>
			<th>&nbsp;</th>
			<th>'.$l_hours.'</th><th>'.$l_mins.'</th><th>'.$l_secs.'</th>
			</tr>'."\n";

	print '<th>signon at:</th>
		   <td><input type="text" size="2" name="dayU1" value="'.
				&UnixDate($dat,"%d").'"></td>
		   <td><input type="text" size="2" name="monU1" value="'.
				&UnixDate($dat,"%m").'"></td>
		   <td>&nbsp;</td>
		   <td><input type="text" size="2" name="hrsU1" value="'.
				&UnixDate($dat,"%H").'"></td>
		   <td><input type="text" size="2" name="minU1" value="'.
				&UnixDate($dat,"%M").'"></td>
           <td><input type="text" size="2" name="secU1" value="'.
				&UnixDate($dat,"%S").'"></td>';
	print '</tr>'."\n";
	print '<th>signoff at:</th>
		   <td><input type="text" size="2" name="dayU2" value="'.
				&UnixDate($dat,"%d").'"></td>
		   <td><input type="text" size="2" name="monU2" value="'.
				&UnixDate($dat,"%m").'"></td>
		   <td>&nbsp;</td>
		   <td><input type="text" size="2" name="hrsU2" value="'.
				&UnixDate($dat,"%H").'"></td>
		   <td><input type="text" size="2" name="minU2" value="'.
				&UnixDate($dat,"%M").'"></td>
           <td><input type="text" size="2" name="secU2" value="'.
				&UnixDate($dat,"%S").'"></td>';
	print '</tr>'."\n";
 
	print '<tr><td align="right" colspan="7"></td></tr>
			</table>
			<input type="submit" value="'.$l_continue.'"></td></tr>
			</form>';
}

# ----------------------------------------
# execute insertion and check for validity
sub exec_insert()
{
	my $err,$cnt,$chk;

	$dat=&ParseDate($dat);
	$err=0;

	print '<b>Attempting to insert new record.</b><br><br><ul>';

	$date1=$data{"dayU1"}.'/'.$data{"monU1"}."-".$this_year." ".
		   $data{"hrsU1"}.":".$data{"minU1"}.":".$data{"secU1"};
	$date2=$data{"dayU2"}.'/'.$data{"monU2"}."-".$this_year." ".
		   $data{"hrsU2"}.":".$data{"minU2"}.":".$data{"secU2"};

	print 'Signed on:  ('.$date1.')<br>';
	print 'Signed off: ('.$date2.')<br><br>';

	# -- first some basic checking
	if (!($d1=&ParseDate($date1))) {
		print 'Error: Illegal date format for sign on.<br>'; $err++;
		print $l_insert_illegal_date_on.'.<br>'; $err++;
	}
	if (!($d2=&ParseDate($date2))) {
		print $l_insert_illegal_date_off.'.<br>'; $err++;
	}
	if ($d1 ge $d2) {
		print $l_insert_equal_or_bad.'.<br>'; $err++;
	}
	if (($d1 ge $dat) || ($d2 ge $dat))
	{
		print $l_insert_future_ref.'.<br>'; $err++;
	}

	# --- now check against old data
	$cnt=0; $chk=0;
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if (($date ge $d1) && ($chk==0)) # wait until date>first entry
		{
			if (($chk==0) &&
				(($date le $d2) || ($date eq $d1) || 
				 ($date eq "nempty") || ($act eq "out"))) # date intersect
			{
				print $l_insert_intersect.'.<br>';

				print '('.$l_prev.'): '.$act.'->';
				if ($date eq "nempty")
				{
					print $l_still_online;
				} else {
					print &UnixDate($date,$date_format);
				}
				print "<br>\n";
				print '('.$l_this.'): '.$text_red.' '.$l_in.'->'.
						&UnixDate($d1,$date_format).
					  '</font><br>('.$l_this.') '.$text_red.' '.$l_out.'->'.
						&UnixDate($d2,$date_format).'</font><br>';

			# --- the record in invalid so we just overwrite the $act and $date
				($foo,$act,$date)=split /;/,$dblist[$cnt+1];
				print '('.$l_next.'): '.$act.'->'.
                        &UnixDate($date,$date_format).'<br>';

				$err++;
			} else {
				$chk=1; # checks OK now push new data onto list.
				push @newlst,$cnt++.";inn;".$d1;
				push @newlst,$cnt++.";out;".$d2;
			}
		}
		push @newlst,$cnt++.';'.$act.";".$date;
	}
	if (($date lt $d1) && ($chk==0))
	{
		push @newlst,$cnt++.";inn;".$d1;
		push @newlst,$cnt++.";out;".$d2;
	}

	print '<br></ul><b>';
	if ($err!=0) 
	{	
		print $l_insert_found.' '.$err.' '.$l_insert_eabort.'.</b><br>';
	} else {
		# --- write to file.
		open DTA,">".$dtafile; # write new datafile
		foreach $line (@newlst)
		{
			($foo,$foo,$dta)=split /;/,$line;
			if ($dta ne "nempty")
			{
				print DTA $line."\n"; 
			}
		}
		close DTA;
		print $l_insert_success.'.</b><br>';
	}

}



# ---------------------------------------------------------------------------
# DELETE
 
# prepare to delete entry 
sub prep_delete()
{
	print '<form action="'.$cgi_action.'" method="POST">';
	print $std_tableL."\n";
	print '<tr><th colspan=3>'.$text_hcolor.$l_select_del_title.'</th></tr>
			<tr><td>&nbsp;</td><th>'.$l_from.'</th><th>'.
				$l_to.'</th></tr>'."\n"; 
	$inn="empty"; $out="empty"; $cnt=0; 
	foreach $line (@dblist)
	{
		($id,$act,$date)=split /;/,$line;
		if ($inn eq "empty")
			{ $inn=$date; } else { $out=$date; }
		if ($out ne "empty") {
			if ($out eq "nempty") { $out=$l_still_online; }
			print '<td><input type="checkbox" name="U'.
					   ($id-1).'" value="unset"></td>
				   <td>'.&UnixDate($inn,$date_format).'</td><td>';
			if ($out eq $l_still_online)
			{
				print $l_still_online;
			} else {
				print &UnixDate($out,$date_format);
			}
		    print '</td></tr>'."\n";
			$inn="empty"; $out="empty"; $cnt++;
		} 
	}
	print '<input type="hidden" name="UACT" value="del.exe">';
	print '<tr><td colspan="3" align="right">
				<input type="submit" value="Delete">
				<input type="reset" value="'.l_reset.'">
			</td></tr>';
	print '</table>'."\n";
}

# --------------------
# execute the deletion
sub exec_delete() {
	my $lcnt;

	foreach $line (@dblist) { # pick the ones not set for deletion
		($id,$act,$date)=split /;/,$line;
		if (($data{"U".$id} eq "unset") || ($data{"U".($id-1)} eq "unset"))
		{
			push @deleted,$line; # for information purposes only
		} else {
			push @newlst,$line;  # these we wanna keep
		}
     	$prev=$line;
  	}

	open DTA,">".$dtafile; # write new datafile
	foreach $line (@newlst)
	{
		($foo,$foo,$dt)=split /;/,$line;
		if ($dt ne "nempty")
		{
   		 	print DTA $line."\n"; 
    	}
  	}
  	close DTA;

  	print "<b>".$l_deleted_lines."</b><p><ul>\n";
  	$cnt=0; 
	$lcnt=0;
  	
	foreach $line (@deleted)
	{
   		($foo,$foo,$line)=split /;/,$line;
       	if (($cnt/2) != (int($cnt/2)))
		{
			print &UnixDate($prev,$date_format);
			if ($line ne "nempty")
			{
				print " to ".&UnixDate($line,$date_format);
			} 
			print "<br>\n";
            $lcnt=1;
		}
       	$cnt++;
       	$prev=$line;
  	}
	print '</ul>';
  	if ($lcnt==0)
	{
     	print "<dd>".$l_nodeleted_lines."<br>";
  	}
}



# ---------------------------------------------------------------------------
# TIME SCHEDULER 

sub exec_schedule2()
{
	my $mon=$data{"UMON"}-1;
	my $dow; # date of week
	my $doy; # day of year
	my $dim; # days in month

	my $s,$h,$d;

	print '<form action="'.$cgi_action.'" method="POST">';
	print $std_tableL.'<tr><th colspan=8>'.$l_work_schedule_for.' '.
				$year_name[$mon].' '.$this_year.'</th></tr>';

	$mon++; # date::manip months starts at 1
	$dim=&Date_DaysInMonth($mon,$this_year);

	print '<tr><th>'.lc($l_week_no).'</th>';
	foreach $day (@week_name)
	{
		print '<th align="center">'.$day.'</th>';
	}
	print '</tr>'."\n";

	for ($cnt=1; $cnt<=$dim; $cnt++)
	{
		$dow=&Date_DayOfWeek($mon,$cnt,$this_year);
		if (($dow==1) || ($cnt==1))
		{
			print '<tr><th>'.
					(&Date_WeekOfYear($mon,$cnt,$this_year,1)+1).'</th>';
			if (($cnt==1) && ($dow!=1))  # week doesn't start on a monday
			{
				for ($cnt2=1; $cnt2<=$dow-1; $cnt2++)
				{
					print '<td>&nbsp;</td>';
				}
			}
		}
		$doy=&Date_DayOfYear($mon,$cnt,$this_year); # this day in this year
		($d,$h,$s)=split /;/,$slist[$doy-1]; # schedules list of this day

		print '<td align="right">
		 		<b>'.$cnt.'/'.$mon.'</b>'.
		' - <input type="text" value="'.$h.'" name="UH'.$doy.'" size=4><br>
		 <select name="US'.$doy.'">
	 	 <option value="'.$s.'"> '.$s;
		if ($s ne "W") { print '<option value="W"> W'; } 
		if ($s ne "N") { print '<option value="N"> N'; } 
		if ($s ne "H") { print '<option value="H"> H'; } 
		if ($s ne "S") { print '<option value="S"> S'; } 
		if ($s ne "V") { print '<option value="V"> V'; }
		if ($s ne "U") { print '<option value="U"> U'; }
		print '</select></td>';
		if (($cnt==$dim) && ($dow ne 7))
		{
			print '<td colspan="'.(7-$dow).'">&nbsp;</td>';
		}
		if (&Date_DayOfWeek($mon,$cnt,$this_year)==7) { print '</tr>'."\n"; } 
	}

	print'<tr><td colspan=8 align=center>
			Abbreviations: W=Workday, N=Non-Workday (Weekend),
			H=National Holliday, S=Sick, V=Vaccation and U=Unspecified.<p>
			</td></tr>';
	print '<tr><td colspan=8 align=right>
			<input type="hidden" name="UACT" value="schedule3">
			<input type="submit" value="'.$l_continue.'">
			<input type="reset" value="'.$l_reset.'">
			</table></form>';
}

# ----------------------------
# execute schedule alternation
sub exec_schedule3()
{
	my $cnt;
	my $s,$h,$d;
	my $m,$d;
	my $er;

	$er=0;
	print '<b>Altering work schedule.</b><p><ul>';
	for ($cnt=1; $cnt<367; $cnt++)
	{
		if (($data{"UH".$cnt}) || ($data{"US".$cnt}))
		{
			($d,$h,$s)=split /;/,$slist[$cnt-1];
			if (($h ne $data{"UH".$cnt}) || ($s ne $data{"US".$cnt}))
			{
				($foo,$m,$d,$foo,$foo,$foo)=&Date_NthDayOfYear($this_year,$cnt);
				print 'Date: '.$d.'/'.$m.' was '.$h.':'.$s.' -> '.
						$data{"UH".$cnt}.':'.$data{"US".$cnt};

				if (($data{"UH".$cnt}<0) || ($data{"UH".$cnt}>24)) {
					print ' <b>Work hours out of range (0-24)!</b>';
					$er=2;
				} else { # no error, I hope.
					$slist[$cnt-1]=$cnt.";".$data{"UH".$cnt}.";".
											$data{"US".$cnt};
					if ($er!=2) {$er=1;}
				}
				print "<br>";
			}
		}	
	}
	print '</ul>';	
	print "\n";
	if ($er==2)
	{
		print '<b>Errors occoured. Data not saved!</b><br>';
	} elsif ($er==1) {
		print '<b>New schedule saved!</b><br>';
		exec_schedule_save();
	} else {
		print '<b>No change. Nothing done.</b><br>';
	}
	print "\n";
}

# -------------------------------
# save new schedule back to disc.
sub exec_schedule_save()
{
    my $dty=&Date_DaysInYear($this_year);
	my $cnt;

	$sfile="data/".$unam.".".$this_year.".schedule.dta";
	open DTA,">".$sfile;
    for ($cnt=1; $cnt<=$dty; $cnt++)
    {
		print DTA $slist[$cnt-1]."\n";
	}
	close DTA;
}



# ---------------------------------------------------------------------------
# WEEKLY REPORTS 

sub select_week() {

	my $mx_week=0; # count up to this week.

	foreach $line (@dblist)
	{
		($id,$action,$date)=split /;/,$line;
		$wk=&UnixDate($date,"%W");
		if (($action eq "inn") && (0==chk_weeklst($wk)))
		{
        	push @av_week,$wk;
			if ($wk>$mx_week) { $mx_week=$wk; }
     	}
  	}

	if ($this_year!=$this_ryear) # looking at previous year.
	{
		$mx_week=&Date_WeekOfYear(12,31,$this_year,1);
	}

	@av_week=();
	for ($cnt=1; $cnt<=$mx_week; $cnt++)
	{
		push @av_week,$cnt;
	}

  	print '<ul><form action="'.$cgi_action.'" method="POST">';
	print $std_tableL.'
  		  	<tr>
				<th colspan="4">'.$text_hcolor.$l_select_week_display.'</th>
			</tr>
  		  	<tr><td>&nbsp;</td>
				<th>'.$l_week_no.'</th>
				<th>'.$l_start.'</th>
		  		<th>'.$l_end.'</th>
			</tr>';

	foreach $line (reverse @av_week)
	{
		$from=&UnixDate(&ParseDate("monday week ".$line." of ".
						$this_year),"%d/%m");
 		$to=&UnixDate(&ParseDate("sunday week ".$line." of ".
						$this_year),"%d/%m");

		print '<tr><td>
				<input type="radio" name="UWEEK" value="'.$line.'"></td>
				<td align="center">'.$line.'</td>
				<td>'.$from.'</td><td>'.$to."</td></tr>"; 
  	}

	print '<tr><td colspan="4" align="right">
				<input type="submit" value="'.$l_continue.'">
			</td></tr>
			</table>
			<input type="hidden" name="UACT" value="week.exe">
			</form></ul>';
 
}

# -----------------------------------------------------------------------
# check if a list has already been pushed onto the "available week list".
sub chk_weeklst()
{
	my ($wno)=@_;
	foreach $l (@av_week)
	{
		if ($l eq $wno) { return 1; } 
	}
	return 0;
}

# ----------------------------------------------
# this computes and prints out weekly statistics
sub mkweek2()
{
	$uweek=$data{"UWEEK"}; # get week number

	my 	$coll;
	my	$date,$dateI,$dateO;
	my 	$delta;
	my	$tt,$tm,$ts; # total hour, minute, second

	for ($cnt=1; $cnt<=8; $cnt++) # initalize week variables
	{
		push @day,"";
		push @dayH,0;
		push @dayM,0;
		push @dayS,0;
		push @dayC,0; # scheduled this day
	}

	$fd=&ParseDate("monday week ".$uweek." ".$this_year);
	$ld=&ParseDate("sunday week ".$uweek." ".$this_year);

	($spre,$spost)=schedule_diff($fd,$ld);

	if ($uweek==1) {$spre=$this_scheduled; }

	$dateI="UNSET"; $dateO="UNSET";
	$tt=0; $tm=0; $ts=0;
	
	foreach $line (@dblist)	
	{
		($id,$action,$date)=split /;/,$line;

		if ($date eq "nempty") { $date=&ParseDate($dat); } # i.e stillon
		$wkno=&UnixDate($date,"%W");

		if ($action eq "inn")
		{
			$dateI=$date;
		} else {
			$dateO=$date;
	
           	$delta=&DateCalc($dateO,$dateI,\$erro); # time spent
           	($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
				
           	while ($uw!=0) { $uw--; $ud=$ud+7; }  # long workhours
           	while ($ud!=0) { $ud--; $ut=$ut+24; } # very long workhours
			$hrs=($ut+(1/60*$um)+(1/3600*$us));
			$wkno=&UnixDate($dateI,"%W");

			$foomonth=&UnixDate($date,"%m");
			if (($wkno < 4) && ($foomonth == 12)) {$wkno=53; } 
#			print "->".$uweek.":".$wkno."<-";
			if ($wkno<$uweek) { $spre=$spre+$hrs; }
			if ($wkno<=$uweek) { $spost=$spost+$hrs; }

			if ($wkno == $uweek) # this is in selected week. count. -----
			{
				$dow=&UnixDate($dateI,"%w"); # day of week

				if ($day[$dow] ne "") { $day[$dow]=$day[$dow]."<br>";}
				$day[$dow]=$day[$dow].
				&UnixDate($dateI,$date_formatT)."<br>".
				&UnixDate($dateO,$date_formatT)."<br>";
				$tt=$tt+$ut; # collected this week!
				$tm=$tm+$um;
				$ts=$ts+$us;

				$dayH[$dow]=$dayH[$dow]+$ut;
				$dayM[$dow]=$dayM[$dow]+$um;
				$dayS[$dow]=$dayS[$dow]+$us;

				# now handle minute and second overflow.
				while ($dayS[$dow]>=60)
				{
					$dayM[$dow]++;
					$dayS[$dow]=$dayS[$dow]-60;
				}
				while ($dayM[$dow]>=60)
				{
					$dayH[$dow]++;
					$dayM[$dow]=$dayM[$dow]-60;
				}
				
			}
			$dateI="UNSET";
		}
	}


	# handle total mins/secs overflow
	while ($ts>=60) { $ts=$ts-60; $tm++; }
	while ($tm>=60) { $tm=$tm-60; $tt++; }

	# now all the data is gathered and we need to do a printout

	print '<ul>'.$std_tableL;
	print '<tr><th colspan=7>'.$text_hcolor.$l_work_stat_week." ".
			($uweek).' for '.$the_user.'</th></tr>';
	print '<tr><th>day</th><th>date</th><th>from/to</th><th>hours</th>
			<th>minutes</th><th>seconds</th><th>scheduled</th></tr>';
	print '<tr><td colspan="6" align="left">&nbsp;</td><th align=right>';

	if ($spre ge 0) { print $text_black; } else { print $text_red; }
	printf "%4.2f",$spre;

	print '</font></th></tr>';
	
	for ($cnt=1; $cnt<=7; $cnt++)
	{
		$fooyear=&UnixDate(&ParseDate($week_name[$cnt-1]." week ".
					$uweek." ".$this_year),"%Y"); # check if year is rigth.

		if ($fooyear eq $this_year)
		{
			print '<tr>';
			print '<td>'.ucfirst($week_name[$cnt-1]).'</td>';
			print '<td>'.&UnixDate(&ParseDate($week_name[$cnt-1]." week ".
								$uweek." ".$this_year),$date_formatD).'</td>';
			if ($day[$cnt]) 
			{
				print '<td>'.$day[$cnt].'</td>';
			} else {
				$foo=cempty($cnt);
				if (($day[$cnt-1] ne "") || ($cnt==1))
				{	
					print '<td rowspan="'.$foo.'">&nbsp;</td>';
				}
				if (($day[$cnt] eq "") &&
 					(&UnixDate(&ParseDate($week_name[$cnt-1]." week ".
						$uweek." ".$this_year),$date_formatD) eq "01/01")) 
		 		{
					print '<td>&nbsp;</td>'; # first day of year needs special treatment
				}
			}
			print '<td align="right">'.$dayH[$cnt].'</td>';
			print '<td align="right">'.$dayM[$cnt].'</td>';
			print '<td align="right">'.$dayS[$cnt].'</td>';

			($foo,$dayC[$cnt],$foo)=split /;/,$slist[&UnixDate(&ParseDate($week_name[$cnt-1]." week ".$uweek." ".$this_year),"%j")-1];
			print '<td align=right>'.$dayC[$cnt].'</td>';
			print '</tr>';
		} else {
			print '<tr>';
			print '<td>'.ucfirst($week_name[$cnt-1]).'</td>';
			            print '<td>'.&UnixDate(&ParseDate($week_name[$cnt-1]." week ".
                                $uweek." ".$this_year),$date_formatD).'</td>';
            print '<td>&nbsp;</td><td colspan="4">&nbsp;</td>';
            print '</tr>';
		}
	}

	print '<tr><td colspan="3">Total</td>';
	print '<td align="right">'.$tt.'</td>
			<td align="right">'.$tm.'</td>
			<td align="right">'.$ts.'</td>';

	print '<td align="right">';
	if ($spost<0) { print $text_red; } else { print $text_black; }
	print '<b>';
	printf "%4.2f",$spost;
	print '</b></td></tr>';

	print '</table></ul>';
}

sub cempty() # counts empty cells below an empty cell (to merge rowspan)
{
	($cnt)=@_;
	my $cntx;

	for ($cntx=$cnt; ($cntx<=7) && ($day[$cntx] eq ""); $cntx++) {}
	return ($cntx-$cnt);	
}



# ---------------------------------------------------------------------------
# show monthly statistics for selected month

sub exec_monthly()
{
	my $mon;
	my $spre;
	my $spost;
	my $tm;

	$mon=$data{"UMON"}; # i.e 1==January

	for ($cnt=0; $cnt<32; $cnt++) { push @mhrs,0; }

	# find scheduled at start of month.
	$fd=&ParseDate('01/'.$mon.'/'.$this_year);
	$ld=&ParseDate(&Date_DaysInMonth($mon,$this_year).
					'/'.$mon.'/'.$this_year);
	($spre,$spost)=schedule_diff($fd,$ld);

	# find actual time worked at a specific day....
	$dateI="empty"; $dateO="empty";
	foreach $line (@dblist)	
	{
		($id,$act,$date)=split /;/,$line;
		if ($date eq "nempty") { $date=&ParseDate($dat); }

		if ($dateI eq "empty")
		{
			$dateI=$date;
		} else {
			$dateO=$date;

			# calculate delta and add it into $hours
			$delta=&DateCalc($dateO,$dateI,\$erro); # time spent
			($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
			while ($uw!=0) { $uw--; $ud=$ud+7; }  # long workhours
			while ($ud!=0) { $ud--; $ut=$ut+24; } # very long workhours
            $hrs=($ut+(1/60*$um)+(1/3600*$us));

			$moy=&UnixDate($dateI,"%f");
			if ($moy<$mon) { $spre=$spre+$hrs; }
			if ($moy<=$mon) { $spost=$spost+$hrs;  }
			if ($moy==$mon)
			{
				$day=&UnixDate($dateI,"%e");
				$mhrs[$day]=$mhrs[$day]+$hrs;
			}
			$dateI="empty";
		}
	}

	print $std_table.
		'<tr><th colspan="9">Monthly report for '.$year_name[$mon-1].
		'</th></tr>'.
		'<tr><td>'.$l_week_no.'</td>';
	foreach $day (@week_name)
	{
		print '<td>'.ucfirst($day).'</td>';
	}
	print '<td>Scheduled</td></tr>'."\n";

	$day=0;
	$dim=&Date_DaysInMonth($mon,$this_year);
	$sflag=0;

	for ($cnt=1; $cnt<=$dim; $cnt++)
	{
		$dow=&Date_DayOfWeek($mon,$cnt,$this_year);
		$woy=&UnixDate(&ParseDate($cnt."/".$mon."/".$this_year),"%W"); # week

		if (($dow==1) || ($cnt==1)) # threat first day special
		{
			print '<tr><td align="center">'.($woy).'</td>';
		}
		print '<td align="right"';

		if ($cnt==1) # first day indented.
		{
			if ($dow!=1)
			{
				print 'colspan="'.($dow-1).'">&nbsp;</td><td align="right"';
			}	
		}
		print ">";

		if ($mhrs[$cnt]!=0) {
			printf "%4.2f",$mhrs[$cnt];
		} else {
			print "0";
		}

		if ($cnt==$dim) # last day of month...
		{
			$foo=(7-$dow);
			if ($foo>0)
			{
				print '<td colspan="'.$foo.'">&nbsp;</td>';
			}
			$sflag=2;
			$dow=7;
		}

		if ($dow==7) # last day of week, schedule and end table row
		{
			print '<td>';
			if ($sflag==1) { print '&nbsp;'; }
			if ($sflag==0) { printf "%4.2f",$spre; $sflag=1; }
			if ($sflag==2) { printf "%4.2f",$spost; $sflag=1; }
			print '</td></tr>'."\n";
		}
	}

	print '</table>'."\n";
}



# ----------------------------------------------------------------------------
# display general user statistics

sub exec_yearly()
{

   my $uday=0; my $utim=0; my $umin=0; my $usec=0;
   my @wkt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   my @wkm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   my @wks=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @mkt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); @mkm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @mks=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); # Month[hour.minute.sec] count
   @dows=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); @dowm=(0,0,0,0,0,0,0,0,0,0,0,0,0,0);
   @dowt=(0,0,0,0,0,0,0,0,0,0,0,0,0,0); # Day of week [hour.minute.sec.] count


# ----------------------------------
# read and analyze data from time db

   $date1="empty"; $date2="empty";
   foreach $line (@dblist) {
       ($id,$action,$date)=split /;/,$line;
       if ($date1 eq "empty") {$date1=$date;} else {$date2=$date;}
       if ($date2 ne "empty") {
          if ($date2 eq "nempty") { # use current datestamp if still online
             $date2=$dat; $stillon=1;
          } else {$stillon=0;}

          $delta=&DateCalc($date2,$date1,\$erro); # time spent
          ($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
          while ($uw!=0) { $uw--; $ud=$ud+7; }
          while ($ud!=0) { $ud--; $ut=$ut+24; }

          ($y)=&UnixDate($date1,"%Y"); # find which week we are in.
          ($m)=&UnixDate($date1,"%m");
          ($d)=&UnixDate($date1,"%d");
          $wkno=&Date_WeekOfYear($m,$d,$y,$first);
											  # now we know what week we have
          $dow=&Date_DayOfWeek($m,$d,$y);     # check which day of week it is

       # add statistics to the misc. tables
          ($wkt[$wkno],$wkm[$wkno],$wks[$wkno])=
                addtms($wkt[$wkno],$wkm[$wkno],$wks[$wkno],$ut,$um,$us);

          ($mkt[$m],$mkm[$m],$mks[$m])=
                addtms($mkt[$m],$mkm[$m],$mks[$m],$ut,$um,$us);
          ($dowt[$dow],$dowm[$dow],$dows[$dow])=
                addtms($dowt[$dow],$dowm[$dow],$dows[$dow],$ut,$um,$us);
          ($utim,$umin,$usec)=addtms($utim,$umin,$usec,$ut,$um,$us);
          while ($utim>=24) {
             $uday++; $utim=$utim-24;
          }
          if ($stillon==1) { # user is still online, print dummy at logof field
              push @list,"<tr><td align=right>".&UnixDate($date1,"%d/%m-%Y %H:%M:%S")."<\/td><td align=right>".$l_still_online."</td><td align=right>".$ut."<\/td><td align=right>".$um."<\/td><td align=right>".$us."<\/td>\n";
          } else {
              push @list,"<tr><td align=right>".&UnixDate($date1,"%d/%m-%Y %H:%M:%S")."<\/td><td align=right>".&UnixDate($date2,"%d/%m-%Y %H:%M:%S")."</td><td align=right>".$ut."<\/td><td align=right>".$um."<\/td><td align=right>".$us."<\/td>\n";
          }
          $date1="empty"; $date2="empty";
       }
   }

# ---------------------------
# sum each weeks' total hours

   for ($cnt=1; $cnt<54; $cnt++) {
      # summarize work each week
      if (($wks[$cnt]!=0) || ($wkm[$cnt]!=0) || ($wkt[$cnt]!=0)) {
        push @week,"<tr><td align=right>".$cnt."<\/td><td align=right>".$wkt[$cnt]."<\/td><td align=right>".$wkm[$cnt]."<\/td><td align=right>".$wks[$cnt]."<\/td><\/tr>\n";
      } 
      # summarize work each month
      if (($cnt<13)&&(($mks[$cnt]!=0) || ($mkm[$cnt]!=0) || ($mkt[$cnt]!=0))) {
           push @month,"<tr><td align=right>".$year_name[$cnt-1]."<\/td><td align=right>".$mkt[$cnt]."<\/td><td align=right>".$mkm[$cnt]."<\/td><td align=right>".$mks[$cnt]."<\/td><\/tr>\n";
      }
      # summarize work each weekday
      if (($cnt<8) && (($dows[$cnt]!=0)||($dows[$cnt]!=0)||($dows[$cnt]!=0))) {
           push @dowli,"<tr><td align=right>".$week_name[($cnt-1)]."<\/td><td align=right>".$dowt[$cnt]."<\/td><td align=right>".$dowm[$cnt]."<\/td><td align=right>".$dows[$cnt]."<\/td><\/tr>\n";
      }
   }

# show scheduled daycodes

$cnt_w=0;
$cnt_n=0;
$cnt_h=0;
$cnt_v=0;
$cnt_s=0;
$cnt_u=0;

for ($cnt=1; $cnt<=$this_day; $cnt++)
{
	($foo,$foo,$dcode)=split /;/,$slist[$cnt-1];
	if ($dcode eq "W") { $cnt_w++; }
	if ($dcode eq "N") { $cnt_n++; }
	if ($dcode eq "H") { $cnt_h++; }
	if ($dcode eq "V") { $cnt_v++; }
	if ($dcode eq "S") { $cnt_s++; }
	if ($dcode eq "U") { $cnt_u++; }
}

# ------------------------------------------------------------
# all processing is done, lets get something out on the screen 

  # statistics for this year

	print '<ul>';
  	print $std_tableL;
  	print '<tr><th colspan="2">'.$text_hcolor.'Scheduled work this year (days)</th>
		</tr>
	       <tr><td>Workdays</td><td>'.$cnt_w.'</td></tr>
			<tr><td>Non-workdays</td><td>'.$cnt_n.'</td></tr>
			<tr><td>National holidays</td><td>'.$cnt_h.'</td></tr>
			<tr><td>Sick</td><td>'.$cnt_s.'</td></tr>
			<tr><td>Vaccation</td><td>'.$cnt_v.'</td></tr>
			<tr><td>Unspecified</td><td>'.$cnt_u.'</td></tr>
			</table><br></ul>';
	
	print '<ul>';
  	print $std_tableL;
  	print '<tr><th colspan=4>'.$text_hcolor.$l_work_this_year.'
             </th>
        </tr>
        <tr><th>'.$l_days.'</th>
            <th>'.$l_hours.'</th>
            <th>'.$l_mins.'</th>
            <th>'.$l_secs.'</th>
        </tr>';
  	print '<tr><td align=right>'.$uday.'</td>
             <td align=right>'.$utim.'</td>
             <td align=right>'.$umin.'</td>
             <td align=right>'.$usec.'</td>
         </tr>
         </table></b>';

  # monthly statistics
  	tblhead4c($l_work_by_month,$l_month,$l_hours,$l_mins,$l_secs,@month);

  # day of week statistics
  	tblhead4c($l_work_by_weekdays,$l_day,$l_hours,$l_mins,$l_secs,@dowli);

  # weekly statistics
  	tblhead4c($l_work_by_week,$l_week_no,$l_hours,$l_mins,$l_secs,@week);

  # statistics by session
  	tblhead5c($l_work_by_sessions,$l_from,$l_to,$l_hours,$l_mins,$l_secs,@list);

	print '</ul>';
}


# ---------------------------------------------------------------------------
# some smaller subs used as tools

sub tblhead5c() { # write a generic table with 5 columns
  my ($txt,$a1,$a2,$a3,$a4,$a5,@list)=@_;
  print "<br>".$std_tableL;
  print '<tr><th colspan=5>'.$text_hcolor.$txt."<\/font><\/th><\/tr>\n";
  print "<tr><th>".$a1."<\/th><th>".$a2."<\/th><th>".$a3."<\/th><th>".$a4."<\/th><th>".$a5."<\/th></tr>\n";
  foreach $line (@list) {
    print $line;
  }   
  print "<\/table>\n";
}

sub tblhead4c() { # write a generic table with 4 columns
  my ($txt,$a1,$a2,$a3,$a4,@list)=@_;
  print "<br>".$std_tableL;
  print '<tr><th colspan=5>'.$text_hcolor.$txt."<\/font><\/th><\/tr>\n";
  print "<tr><th>".$a1."<\/th><th>".$a2."<\/th><th>".$a3."<\/th><th>".$a4."<\/th></tr>\n";
  foreach $line (@list) {
    print $line;
  }   
  print "<\/table>\n";
}

# take two sets of HHMMSS and adds them together (6 parameters in, 3 out).
sub addtms()
{
	my ($t,$m,$s,$t2,$m2,$s2)=@_;

	$s=$s+$s2;
	if ($s>=60) { $s=$s-60; $m++; }
	$m=$m+$m2;
	if ($m>=60) { $m=$m-60; $t++; }
	$t=$t+$t2;
	return ($t,$m,$s);
}

# -------------------------------------------------------------
# check username and password (we'll need to add crypting here)
sub chk_user()
{
	($unam,$upwd)=@_;
	my ($una,$upw);
	my $the_user="";

	open PWD,"<time.pwd";
	while (<PWD>)
	{
		chomp;
		($una,$gcos_name,$upw)=split /:/;
	
		$salt=substr($upw,0,2);
		$ncrypt=crypt($upwd,$salt);
		
		if (($una eq $unam) && ($upw eq $ncrypt))
		{
			$the_user=$gcos_name;
		}
	}
	return ($the_user);
}

# ------------------------
# the top of the HTML page
sub head()
{
	($menuflag)=@_; # 1==main menu, print copyright.

	if ((-e 'data/'.$unam.'.prefs') && ($menuflag ne "nc"))
	{
		open TXT,"<data/".$unam.".prefs" || print "cant read from pref file.";
		while (<TXT>)
		{
			chomp;
			($cmd,$parm)=split /:/;
			if ($cmd eq "cs") { $scheme=$parm; color_scheme($parm);}
		}	
        close TXT;
	}

	print '<html><head><title>Time Manager</title></head>'."\n";
	print '<body bgcolor="'.$screen_bgcolor.'" text="'.$text_color.'"
				 vlink="'.$text_vlink.'" alink="'.$text_alink.'"
				 link="'.$text_link.'">'."\n";
	print '<table width="100%">
		   <tr><td align=left><font size="-1"><b>
			'.$NAME." v".$VERSION.'</b></font></td>
			<td align=right><font size="-1">
				<b>by
				<a href="http://www.ekran.no/">Ekran Design</a>
			</b></font></td></tr></table>';
	print "<hr noshade>\n";
}

# ---------------------------
# the bottom of the HTML page
sub tail()
{
	($menuflag)=@_; # 0==print logout/menu options  2== print user status.
	my $delta,$gen;	

	print '<br><hr noshade>';

	print '<table width="100%">
            <tr><td align=left>';
	if ($menuflag==0)
	{
		print '<font size="-1"><b>[<a href="'.$cgi_url.'?menu">menu</a>]';
		print '[<a href="'.$cgi_url.'?UACT=logout">logout</a>]</b></font>';
		print '</font>';
	} elsif ($menuflag==2) {
		print '<font size="-1"><b>You ';
		if ($stillon==1)
		{
			$chk=0;
			print "have been signed on since ";
			$myco=0;	
			foreach $line (@dblist)
			{
				($foo,$foo,$timex)=split /;/,$line;
				$myco++;
				if (&ParseDate($timex)) { $gen=$timex; }
			}
			$delta=&DateCalc($gen,&ParseDate($dat),\$err);
        	($foo,$foo,$uw,$ud,$ut,$um,$us)=split /:/,$delta;
			print &UnixDate($gen,$date_format).' (i.e. for ';
			if ($uw ne 0) { print $uw." weeks "; $chk=1;} 
			if (($chk==1) || ($ud ne 0)) { print $ud." days "; } 
			if (($chk==1) || ($ut ne 0)) { print $ut." hours "; } 
			if (($chk==1) || ($um ne 0)) { print $um." minutes "; } 
			if (($chk==1) ||($us ne 0)) { print $us." seconds."; } 
			print ")";
		} else {
			print "are not signed on.";
		}
		print '</b></font>';	
	}
	
	print '</td>
		<td align=right><font size="-1"><b>';
    if ($the_user) { print $the_user.', '; }
	print &UnixDate($dat,$date_format).'<br></font></td>
		</tr></table></body></html>';
	print "\n";
}

# -------------------------------------------------------------
# read datafile and return db+number of entries.

sub read_datafile()
{
	my ($unam)=@_;
	my @dblist;
	
	$entries=0; $id="";

	$dtafile="data/".$unam.".".$this_year.".dta"; # the user database.
	open DTA,"<".$dtafile; # read and buffer datafile
	while ($i=<DTA>)
	{
		chomp $i;
		$entries++;
		push @dblist,$i; # push data onto a list that we'll later use
		($id,$tmp)=split /;/,$i;
	}
	close DTA;
	if ($id) { $next_entry=$id; } else { $next_entry=1; }
	if (substr($tmp,0,3) eq "inn") # add "nempty" if user is still online
	{
		push @dblist,($next_entry+1).";out;nempty";
		$stillon=1;
	} else {
		$stillon=0;
	}
	return (@dblist,$entries);
}

# --------------------------------------------------------------
# read schedulefile if exist, if not, then create it and read it

sub read_sfile()
{
	my ($unam)=@_;
	my $dty=&Date_DaysInYear($this_year);

	$sfile="data/".$unam.".".$this_year.".schedule.dta";
	if (!-f $sfile)
	{
		# did not find a schedule file. Now we'll have to try to create one.
		open DTA,">".$sfile;
		for ($cnt=1; $cnt<=$dty; $cnt++)
		{
			print DTA $cnt.';';
			($y,$m,$d,$foo,$foo,$foo)=&Date_NthDayOfYear($this_year,$cnt);
			$foo=&ParseDate($d." ".$year_name[$m-1]." ".$y);
			if (&Date_IsWorkDay($foo,0)==1)
			{
				print DTA $hours_a_day.";W\n";
			} else {
				print DTA "0;N\n";
			}
		}
		close DTA;
	}

	open DTA,"<".$sfile; # now read the file
	while (<DTA>)
	{
		chomp;
		push @slist,$_;
	}
	close DTA;

	return (@slist);
}



# --------------------------------------------------
# general month selection (parameter is next action)
sub monthly_select() 
{
	($nact)=@_; # next_action

	my $cnt;
	my $bolt='<input type="radio" name="UMON" value="';

	print '<ul><form action="'.$cgi_action.'" method="POST">';
	print $std_tableL."\n";
	print '<tr><th colspan=2>'.$text_hcolor.$l_select_month.'
			</th></tr>
			<tr><td width=50%>';

	for ($cnt=1; $cnt<=12; $cnt++)
	{
		if ($cnt<7) { print $bolt.$cnt.'">'.$year_name[$cnt-1].'<br>'; }
		if ($cnt==7) { print '</td><td align=right>'; }
		if ($cnt>=7) { print $year_name[$cnt-1].$bolt.$cnt.'"><br>'; }
	}

	print '</td><tr><td colspan="2" align="center">
				<input type="submit" value="'.$l_continue.'">
			</td></tr>
			</table>
			<input type="hidden" name="UACT" value="'.$nact.'">
			</form></ul>';
}

# ---------------------------------------------
# returns scheduled hours at two specific dates (usually first and last day of week
sub schedule_diff()
{
	my ($dc1,$dc2)=@_;

	my $spre;
	my $spost;
	my $tm;

	$dc1=&UnixDate($dc1,"%j"); # day of year start
	$dc2=&UnixDate($dc2,"%j"); # day of year stop

	$spre=-$this_scheduled; $spost=-$this_scheduled; # start of year
	for ($cnt=1; $cnt<=$dc2; $cnt++)
	{
		($foo,$tm,$foo)=split /;/,$slist[$cnt-1];
		if ($cnt<$dc1) { $spre=$spre+$tm; }
		if ($cnt<=$dc2) { $spost=$spost+$tm; } 
	}
	$spre=-$spre; $spost=-$spost;

	return ($spre,$spost);
}

# -------------------------------------
# selecting colours for the HTML output

sub color_scheme()
{
	($cid)=@_;

	# default (i.e. 1) -- dull

	$screen_bgcolor="#e0e0d0";
	$table_bgcolor="#d5d5c5";

	$text_hcolor='<font color="#000070">';
	$text_red='<font color="#800000">';
	$text_black='<font color="#000000">';
	$text_color='#000000';

	$text_alink="#ffffff";
	$text_link="#0000ee";
	$text_vlink="#551a8b";

	if ($cid==2) # orange
	{
		$screen_bgcolor="#ffc695"; 
		$table_bgcolor="#efb685";
		$text_hcolor='<font color="#500000">';
		$text_red='<font color="#800000">';
		$text_black='<font color="#000000">';
		$text_link="#a00000";
		$text_vlink="#e03030";
	}

	if ($cid==3) # toxic
	{
		$screen_bgcolor="#bbff82";
		$table_bgcolor="#70c08d";
		$text_hcolor='<font color="#004000">';
		$text_alink="#ff9000";
		$text_link="#50a000";
		$text_vlink="#909000";
	}

	if ($cid==4) # gray
	{
		$screen_bgcolor="#b0b0b0";
		$table_bgcolor="#a0a0a0";
		$text_hcolor='<font color="#404040">';

		$text_alink="#000000";
		$text_link="#606060";
		$text_vlink="#404040";
	}

	if ($cid==5) # blueberry
	{
		$screen_bgcolor="#6000a0";
		$table_bgcolor="#a060b0";

		$text_color='#e0e0ff';
		$text_hcolor='<font color="#000080">';
		$text_alink="#ffa0ff";
		$text_link="#ffffff";
		$text_vlink="#eeeeee";
	}

	if ($cid==6) # be
	{
		$screen_bgcolor="#34669c";
		$table_bgcolor="#fcca04";

		$text_color='#000000';
		$text_hcolor='<font color="#000080">';
		$text_alink="#ffd0ff";
		$text_link="#ffffff";
		$text_vlink="#eeeeee";
	}

	if ($cid==7) # darkness
	{
		$screen_bgcolor="#000000";
		$table_bgcolor="#505050";

		$text_color='#909090';
		$text_hcolor='<font color="#000000">';
		$text_alink="#909090";
		$text_link="#909090";
		$text_vlink="#909090";
	}

	if ($cid==8) # caramel fudge
	{
		$screen_bgcolor="#d68c00";
		$table_bgcolor="#ffcc86";

		$text_color='#000000';
		$text_hcolor='<font color="#000000">';
		$text_alink="#993300";
		$text_link="#995500";
		$text_vlink="#994400";
	}

	if ($cid==9) # colgate
	{
		$screen_bgcolor="#33ccff";
		$table_bgcolor="#58beff";

		$text_color='#000000';
		$text_hcolor='<font color="#000000">';
		$text_alink="#000040";
		$text_link="#000040";
		$text_vlink="#000040";
	}


	$std_table='<table border=1 cellpadding=2 bgcolor="'.
					$table_bgcolor.'" align="center">';
	$std_tableL='<table border=1 cellpadding=2 bgcolor="'.$table_bgcolor.'">';
}

# ------------------------------------------------
# a brief implementation of the norwegian language

# norwegian (and maybe other languages will be supported later.

sub lang_eng()
{
	$l_action_n_spec="You forgot to specify action (signon/signoff/etc..)";
	$l_auth_failed="Username and/or password was not written correctly!";
	$l_bad_seq="You are trying to signon or signoff two times in a row!";
	$l_confirm_action="registered";
	$l_work_stats_for="Work-time statistics for";
	$l_still_online="-- still at work --";
	$l_select_del_title="Select which entry you want to delete";
	$l_select_week_display="Select week to display:<p>";
        $l_select_month_sched='Select which month to reschedule';
	$l_deleted_lines="The following entries was deleted:";
	$l_nodeleted_lines="No lines were deleted.";
 	$l_work_schedule_for="Work schedule for";

	$l_alter_entries="Altering entries.";
	$l_alter_eprealt="can not alter the time/date to a time/date earlier".
	" than the previous log entry (time/date will overlap.)";
	$l_alter_enextalt="can not alter the time/date to a time/date later than the next log entry (time/date will overlap.)";
	$l_alter_futurealt="the time/date you tried to alter to is in the future.";
	$l_alter_illegaldate="the time/date you entered is illegal";
	$l_alter_current="current";
	$l_alter_new="new";
	$l_alter_next="next";
	$l_alter_prev="previous";
	$l_alter_failed="failed";
	$l_alter_noch="no change";
	$l_alter_ch="changed";
	$l_alter_changeent="Alter entry";
	$l_alter_select_entry="Select entry to alter";
	$l_alter_nextillegal="Change failed because next entry is illegal";

	$l_logedout='You have loged out from the system.<br>Have a nice day.';
  	$l_work_by_sessions="Workhours by sessions";
  	$l_work_by_weekdays="Workhours by weekdays";
  	$l_work_by_week="Workhours by week";
  	$l_work_by_month="Workhours by month";
  	$l_work_this_year="Workhours this whole period (year)";
  	$l_work_stat_week="Workhours for week no.";

	$l_select_month='Select month.';
	$l_insert_success='Insertion successfull';
	$l_insert_found='Found';
	$l_insert_eabort='errors. Insertion aborted';
	$l_insert_itersect='Error: Insertion date intersect old entry';
	$l_insert_future_ref='Error: Sign on and sign off are future references';
	$l_insert_equal_or_bad='Error: Sign on and sign off are equal'.
		' or sign on are later than sign off';
	$l_insert_illegal_date_on='Error: Illegal date format for sign on';
	$l_insert_illegal_date_off='Error: Illegal date format for sign off';
	$l_insert_please_write='Please write insertion entry';

	$l_this='this';
	$l_prev='prev';
	$l_next='next';

	$l_in='in';
	$l_out='out';

	$l_continue='Continue';
	$l_reset='Clear';

	$l_month="month";
  	$l_week_no="week no.";
  	$l_day="day";
  	$l_days="days";
  	$l_from="from";
  	$l_to="to";
  	$l_hours="hours";
  	$l_mins="minutes";
  	$l_secs="seconds";
  	$l_total="total";
  	$l_week_no="Week No.";
  	$l_start="Start";
  	$l_end="End";

  	@year_name=("January","February","March","April","May","June","July","August","September","October","November","December");
	@week_name=("monday","tuesday","wednesday","thursday","friday","saturday","sunday");

}


